searchNodes=[{"doc":"Schrodinger Check any struct against multiple valid and invalid state definitions See README for more information","ref":"Schrodinger.html","title":"Schrodinger","type":"module"},{"doc":"Checks if the struct matches in of the invalid states defined in @invalid_state","ref":"Schrodinger.InvalidStates.html","title":"Schrodinger.InvalidStates","type":"module"},{"doc":"","ref":"Schrodinger.InvalidStates.html#get_matches/1","title":"Schrodinger.InvalidStates.get_matches/1","type":"function"},{"doc":"Makes sure that struct matches at least one of the valid states, returns a list of matches and a map of errors","ref":"Schrodinger.ValidStates.html","title":"Schrodinger.ValidStates","type":"module"},{"doc":"","ref":"Schrodinger.ValidStates.html#get_errors/1","title":"Schrodinger.ValidStates.get_errors/1","type":"function"},{"doc":"","ref":"Schrodinger.Validation.html","title":"Schrodinger.Validation","type":"module"},{"doc":"","ref":"Schrodinger.Validation.html#t:t/0","title":"Schrodinger.Validation.t/0","type":"type"},{"doc":"The individual validations that a field can have checked against it. 2 element tuples with check type and data","ref":"Schrodinger.Validations.html","title":"Schrodinger.Validations","type":"module"},{"doc":"","ref":"Schrodinger.Validations.html#check/3","title":"Schrodinger.Validations.check/3","type":"function"},{"doc":"","ref":"Schrodinger.Validations.html#t:validation/0","title":"Schrodinger.Validations.validation/0","type":"type"},{"doc":"","ref":"Schrodinger.ValidationError.html","title":"Schrodinger.ValidationError","type":"exception"},{"doc":"Schrodinger Check any struct against multiple valid and invalid state definitions. This library is a lightweight alternative to using Ecto Changesets or other more involved libraries, when all you want is to validate whether a struct is within acceptable parameters, and keep the definition of &quot;what is acceptable&quot; in the same place where the struct is defined. I originally envisioned this as being a quick way to define an API for a bounded context within an app, to validate what is passed in from other contexts.","ref":"README.html","title":"Schrodinger","type":"extras"},{"doc":"Add use Schrodinger to any module defining a struct below the defstruct or schema blocks. This is necessary for the library to be able to read the struct definition. defmodule Parameters do defstruct [:name, :email, :content] # This could also be an Ecto Schema use Schrodinger end Next, add at least one @valid_state module attribute, and zero or more @invalid_state module attributes to that same module. It is a tuple where the first parameter is an atom identifying the name of the state and the second is a map of the parameter validations. @email_regex ~r/^[A-Za-z0-9._%+-+&#39;]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,4}$/ @valid_state {:contact_form, %{email: [presence: true, format: @email_regex], content: [presence: true, type: :string]}} @valid_state {:anonymous_comment, %{content: [presence: true, type: :string]}} @invalid_state {:name_without_email, %{name: [presence: true], email: [presence: false]}} And then you can query if the struct is valid iex(1)&gt; Parameters.valid?(%Parameters{email: &quot;test@test.com&quot;, content: &quot;THIS IS CONTENT&quot;}) true For a struct to be valid, it must match at least one valid state and match none of the invalid states.","ref":"README.html#usage","title":"Schrodinger - Usage","type":"extras"},{"doc":"valid?/1 returns true / false valid?/2 returns true / false, the second argument is an atom or list of atoms which define which valid states can be checked. There is no filtering of invalid states. This &quot;tightens&quot; the rules. validate/1 returns {:ok, struct} or {:error, Schrodinder.Validation{}} validate/2 has the same return values and can be passed a state atom or a list of states just like valid?/2 validate!/1 returns struct or raises a Schrodinder.ValidationError{} validate!/2 has same arguments as valid?/2","ref":"README.html#public-api","title":"Schrodinger - Public API:","type":"extras"},{"doc":"Validation options are keyword lists, the following options are available: presence: BOOLEAN BOOLEAN can be true or false. Only a nil value or missing key is considered &#39;absent&#39; inclusion: [LIST OF ITEMS] exclusion: [LIST OF ITEMS] format: [REGEX] This will also check that the value is present and that it is a string type: TYPE TYPE can be one of :atom, :string, :integer, :boolean, :list, :map, :number, :struct atoms do not include true, false, and nil a struct is a map, but a map is not a struct","ref":"README.html#validation-options","title":"Schrodinger - Validation Options","type":"extras"},{"doc":"This library can be installed by adding schrodinger to your list of dependencies in mix.exs. It has no dependencies. def deps do [ {:schrodinger, &quot;~&gt; 0.1.0&quot;} ] end","ref":"README.html#installation","title":"Schrodinger - Installation","type":"extras"},{"doc":"Changelog","ref":"CHANGELOG.html","title":"Changelog","type":"extras"},{"doc":"Initial release","ref":"CHANGELOG.html#v0-1-0-2020-5-10","title":"Changelog - v0.1.0 (2020-5-10)","type":"extras"}]